{ hostName, inputs, pkgs, options, lib, ... }:

{
  nix = {
    package = pkgs.nixFlakes;
    extraOptions = "experimental-features = nix-command flakes";
    registry = {
      nixpkgs.flake = inputs.nixpkgs;
      zentralwerk-network.flake = inputs.self;
    };
  };

  environment.systemPackages = with pkgs; [
    vim screen git wget
    tcpdump iputils bridge-utils mtr traceroute
    dhcpcd
  ];

  networking.hostName = hostName;

  users.users.root.initialHashedPassword = "";

  virtualisation = lib.optionalAttrs (builtins.hasAttr "qemu" options.virtualisation) {
    memorySize = 4096;
    msize = 65536;
    cores = 4;
    qemu.options = [ "-enable-kvm" ];
  };

  system.stateVersion = "20.09";
}
